// BorrowerSplitFile.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.0. 2003.05.20
 * Copyright 2003 by Michael Claudius
 * All rights reserved
 */

package library2007;

import java.io.*;

public class BorrowerSplitFile {
    
    private Borrower aBorrower;
    private String inputFileName, childFileName, adultFileName;
    
    BorrowerSplitFile(String inputFileName, String childFileName, String adultFileName) {
        
        this.inputFileName = inputFileName;
        this.childFileName = childFileName;
        this.adultFileName = adultFileName;
    }
    
    //*Read and split the file directly into two collections//
    public void doIt() {
        
        try {
            FileInputStream     fis = new FileInputStream(inputFileName);
            ObjectInputStream   ois = new ObjectInputStream(fis);
            
            BorrowerCollection adults = new BorrowerCollection();
            BorrowerCollection childs = new BorrowerCollection();
            
            //Reads borrower from file and add to childs or adults collection
            int number = ois.readInt();
            for (int i = 0; i < number; i++) {
                aBorrower = (Borrower)ois.readObject();
                if ( (aBorrower.getBType()).equals("Child") )
                    childs.addBorrower(aBorrower);
                else
                    adults.addBorrower(aBorrower);
            }      
            
            //Best solution is to utilise BorrowerWriteFile
            BorrowerWriteFile cmc_WriteFile = new BorrowerWriteFile(childs,childFileName);
            cmc_WriteFile.doIt();
            
            cmc_WriteFile = new BorrowerWriteFile(adults,adultFileName);
            cmc_WriteFile.doIt();
            
            ois.close();
            
        }//try
        
        catch (IOException ex) {
            System.out.println(ex.getMessage());
            ex.printStackTrace();
        }
        
        catch (ClassNotFoundException ex) {
            System.out.println(ex.getMessage());
            ex.printStackTrace();
        }
        
    }// doIt
    
    //* Read file into colletion and split into two collections //
    public void doItEasy() {
        
        BorrowerCollection adults = new BorrowerCollection();
        BorrowerCollection childs = new BorrowerCollection();
        BorrowerCollection all = new BorrowerCollection();
        
        BorrowerReadFile cmc_ReadFile = new BorrowerReadFile(all,inputFileName);
        cmc_ReadFile.doIt();
        
        int n = all.numberOfBorrowers();
        
        for (int i = 0; i < n; i++) {
            aBorrower = all.getBorrower(i);
            if ( (aBorrower.getBType()).equals("Child") )
                childs.addBorrower(aBorrower);
            else
                adults.addBorrower(aBorrower);
        }
       
        //Best solution is to utilise BorrowerWriteFile
        BorrowerWriteFile cmc_WriteFile = new BorrowerWriteFile(childs,childFileName);
        cmc_WriteFile.doIt();
        
        cmc_WriteFile = new BorrowerWriteFile(adults,adultFileName);
        cmc_WriteFile.doIt();
        
    }// doItEasy
    
}// class
