// ItemCatalog .java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.5. 2006.04.28
 * Copyright 2006 by Michael Claudius
 * All rights reserved ?
 */

package library2007;

import java.util.*;
import java.io.*;

public class ItemCatalog implements Serializable {
    
    // Ass. 3 declaration of data fields
    private List <Item> data;
    
    
    /** Ass. 3 Declaration of constructors */
    ItemCatalog() {
        data = new ArrayList<Item>();
    }//constructor
    
    /** Ass. 3 Add a Item always; return true */
    public boolean addItem(Item aItem) {
        data.add(aItem); //using the List operation!
        return true;
    }
    
    /** Ass. 3 Extra: Create and add a Item; always return true */
    public boolean createItem(String itemNo, String name, String bType,
    int year) {
        Item aItem = new Item(itemNo, name, bType, year);
        data.add(aItem);//using the List operation!
        return true;
    }
    
    /** Ass. 3 building up a string of Items data, used if anonymous types in List */
    public String allItemsData() {
        Item b;
        String s = "\n";
        for (int i=0; i < data.size(); i++) {
            b = (Item) data.get(i);
            s = s + b.itemData() + "\n";
        }
        return s;
    }
    
    //Alternatively
    /** Ass. 3 building up a string of Items data */
    public String toString1() {
        return data.toString();
        
    }
    
    /** Ass. 3 building up a string of Items data */
    public String toString() {
        String s = "\n";
        for (Item item: data) 
            s = s + item.toString() + "\n";
        return s;
    }
    
    /** Ass. 5 Note there is no maximum of Items */
    public int getNoOfItems() {
        return data.size();
    }
    
    
    /** Ass. 7 Check index. Typecast and return aItem */
    public Item getItem(int index) {
        if (index >= 0 && index < data.size() ){
            Item b = (Item) data.get(index);
            return b;
        }
        else
            return null;
    }
    
    /** Ass. 8 Traverse collection. Typecast and return aItem */
    public Item getItem(String itemNo) {
        Item aItem;
        String myItemNo;
        for (int index=0; index < data.size(); index++) {
            aItem = (Item) data.get(index);
            myItemNo = aItem.getItemNo();
            if ( myItemNo.equals(itemNo) ) {
                return aItem;
            }
        }
        return null; // not found
    }
    
    
    /** Ass. 9 Check index. Typecast and remove aItem */
    public Item removeItem(int index) {
        if (index >= 0 && index < data.size() ) {
            Item aItem = (Item) data.remove(index);
            //data.remove(index);
            return aItem;
        }
        else
            return null;
    }
    
    
    /** Ass. 10 Traverse collection. Typecast and return aItem */
    public Item removeItem(String itemNo) {
        String myItemNo;
        for (Item aItem: data) {
            myItemNo = aItem.getItemNo();
            if ( myItemNo.equals(itemNo) ) {
                data.remove(aItem);
                return aItem;
            }
        }  
        return null; // not found
    }
    
    
    
    // Alternatively
    /** Ass. 10 Utilize getItem. Typecast and return aItem */
    public Item removeItemNew(String itemNo) {
        Item aItem;
        String myItemNo;
        aItem = getItem(itemNo);
        if (aItem != null) {
            //found one to be removed
            data.remove(aItem);
            return aItem;
            
        }
        
        return null; // not found
    }
    
    /** Ass. X Search and remove objects.
     * Returns number of removed objects */
    public int removeItems1(int year, String itemType) {
        Item aItem;
        String myType;
        int myYear, number = 0;
        for (int index=0; index < data.size(); index++) {
            aItem = (Item) data.get(index);
            myYear = aItem.getYear();
            myType = aItem.getItemType();
            if ( myType.equals(itemType) && (myYear < year) ) {
                data.remove(index);
                number++;
                index--; //as the arraylist is shrinking
            }
        }
        
        return number; // number of items found and removed
    }
    
   /** Ass. X Search and remove objects.
     * Returns number of removed objects */
    public int removeItems(int year, String itemType) {
        String myType;
        int myYear, number = 0;
        for (Item aItem: data) {
            myYear = aItem.getYear();
            myType = aItem.getItemType();
            if ( myType.equals(itemType) && (myYear < year) ) {
                data.remove(aItem);
                number++;
            }
        }
        
        return number; // number of items found and removed
    }
   
    
    /** Ass. Y Search and remove objects.
     * Returns removed objects as a collection */
    public ItemCatalog removeItemsSpecial(int year, String itemType) {
        ItemCatalog removedItems = new ItemCatalog();
        String myType;
        int myYear;
        for (Item aItem: data){
            myYear = aItem.getYear();
            myType = aItem.getItemType();
            if ( myType.equals(itemType) && (myYear < year) ) {
                data.remove(aItem);
                removedItems.addItem(aItem);
            }
        }
        
        return removedItems; // number of items found and removed
    }
    
    
    /** Pouls and Michaels use case example */
    public ItemCatalog getItemsFromTitles(String title) {
        Item aItem;
        String myTitle;
        ItemCatalog foundItems = new ItemCatalog();
        for (int index=0; index < data.size(); index++) {
            aItem = (Item) data.get(index);
            myTitle = aItem.getTitle();
            if ( myTitle.equals(title) ) {
                foundItems.addItem(aItem);
            }
        }
        return foundItems;
    }
    
    /** Ass. 4 Create objects and add to collection */
    public static void main(String[] args) {
        // TODO code application logic here
        ItemCatalog ItemCol = new ItemCatalog();
        
        Item b1 = new Item("ISBN 561-777", "TheBoss", "Book", 2003);
        Item b2 = new Item("15081-7777", "Zhen Zhao", "CD", 2005,"Lost");
        Item b3 = new Item("10080-7777", "Vaida Caiser", "DVD", 2005, "Available");
        
        ItemCol.addItem(b1);
        ItemCol.addItem(b2);
        ItemCol.addItem(b3);
        System.out.println(ItemCol.allItemsData());
        System.out.println(ItemCol.toString());
        System.out.println(ItemCol);
        
    }
    
    
    
}
